<script>
export default {
  props: {
    testVariant: {
      type: Number,
      required: false,
      default: null,
    },
    formData: {
      type: Object,
      required: true,
      default: null,
    },
  },
  data() {
    return {
      submitSuccess: false,
    };
  },
  mounted() {
    this.refreshForm();
  },
  methods: {
    refreshForm() {
      window.MktoForms2.setOptions({
        formXDPath: '/rs/194-VVC-221/images/marketo-xdframe-relative.html',
      });

      window.MktoForms2.loadForm(
        '//page.gitlab.com',
        '194-VVC-221',
        3312,
        (form) => {
          form.onSuccess(() => {
            this.submitSuccess = true;

            // eslint-disable-next-line no-undef
            dataLayer.push({
              event: 'sales',
              mktoFormId: form.getId(),
              eventCallback() {
                form.getFormElem().hide();
              },
              eventTimeout: 3000,
            });
            return false;
          });

          function getgacid() {
            try {
              // eslint-disable-next-line no-undef
              const tracker = ga.getAll()[0];
              return tracker.get('clientId');
            } catch (e) {
              return 'n/a';
            }
          }

          form.vals({
            gacid: getgacid(),
          });
        },
      );
    },
  },
};
</script>

<template>
  <div class="mkto-roi-form-wrapper optional">
    <div v-if="!submitSuccess" class="form-header">
      <SlpTypography variant="heading4-bold" tag="h3">
        {{ formData.contactUs }}
      </SlpTypography>
      <SlpTypography variant="body2" tag="p">
        {{ formData.requiredFields }}
      </SlpTypography>
    </div>
    <div v-if="submitSuccess">
      <SlpTypography variant="heading4-bold" tag="h3">{{
        formData.submissionReceived
      }}</SlpTypography>
    </div>

    <form id="mktoForm_3312"></form>
  </div>
</template>

<style lang="scss" scoped>
.mkto-roi-form-wrapper {
  max-width: 860px;
  margin: 0 auto;
  box-shadow: 0px 8px 50px -16px #d1d0d3;

  h3 {
    margin-bottom: $spacing-16;
    text-align: left;
  }
  p {
    font-style: italic;
    margin-bottom: $spacing-16;
    text-align: left;
  }
}
.mkto-roi-form-wrapper.optional {
  background: $color-surface-100;
  padding: 40px $spacing-96;
  border-radius: 0 0 $spacing-8 $spacing-8;
  border: 2px solid $color-surface-200;

  @media (max-width: $breakpoint-md) {
    padding: 0 $spacing-16 40px $spacing-16;
  }
}

.mkto-roi-form-wrapper .mktoForm {
  @media (min-width: $breakpoint-md) {
    display: grid;
    grid-template-columns: 1fr 1fr;
    grid-column-gap: 30px;
    -moz-column-gap: 30px;
    column-gap: 30px;
  }
}

.form-header {
  @media (max-width: $breakpoint-md) {
    padding: 40px 10px 0 10px; // matches padding added to form from Marketo
  }
}

// Marketo-specific style overrides are located in _marketo.scss
</style>
